' =======================================================================
' GPCMDAT - un programma per trasmettere i tempi dei Rally
'           pensato per essere usato assieme a FreeWinRally
'
'                 COPYRIGHT 1999-2008 IW1CNF & I1EPJ
' =======================================================================
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
'
' =======================================================================

' -----------------------------------------------------------------------
' Dichiarazioni ed inizializzazioni varie
' -----------------------------------------------------------------------
DECLARE SUB StrLget (Riga$, Def$, MaxLun%, AlNum%, Fg%, Bg%)
DEFINT A-Z
CLS

Versione$ = "GPCMDat v2.6"

DIM TNCCmds$(30)
DIM Stampa$(12)
DIM I$(10)
DIM Conco$(5)
DIM MINU$(5)
DIM Seco$(5)
DIM Deci$(5)
DIM Comm$(5)
DIM Note$(2)
DIM Fogli$(100)
DIM SHARED Cursore AS INTEGER
DIM SHARED SfondoCursore AS INTEGER

OldTop = 1
OldBottom = 4
TermRow = 19
TermCol = 1
Toggle = 0
FineProgramma = 0
LOGGING = 1
AutoInit = 1
nrec = 0

COM1$ = "COM1:"
COM2$ = "COM2:"
BAUD$ = "9600,"
PARM$ = "N,8,1,BIN,CD0,CS0,DS0,OP0,TB2048,RB2048"

'
' Definizione colori per display a colori (Default)
'
Sfondo = 1
SfondoConc = 7
SfondoTempi = 7
SfondoNote = 7
Fronte = 7
FronteHi = 15
Titolo = 14
Menu = 12
SfondoMenu = 0
Cursore = 15
SfondoCursore = 4
CarattereTX = 10
rally = 14
SfondoRally = 4
Prova = 0
SfondoProva = 3
Conc = 0
SfondoConc = 1
Num = 15
SfondoNum = 6
TitoliFoglio = 14
Tempo = 15
SfondoTempo = 2
Comm = 15
SfondoComm = 5
Note = 15
SfondoNote = 3
Dom = 15
SfondoDom = 3
Errore = 14
SfondoErrore = 4
FileTit = 15
SfondoTit = 5
FileCurs = 14
SfondoCurs = 4
File = 14
SfondoFile = 3
Ombra = 0
Aiuto = 15
ora = 15
Terminale = 2
PremiTasto = 15
Ingresso = 15
Testo = 15
SfondoTesto = 3

' -----------------------------------------------------------------------
' Gestione linea di comando
' -----------------------------------------------------------------------
IF INSTR(COMMAND$, "/M") <> 0 THEN
        '
        ' Definizione colori per display monocromatici
        '
        Sfondo = 0
        SfondoTempi = 7
        SfondoComm = 7
        SfondoNote = 7
        Fronte = 7
        FronteHi = 15
        Titolo = 15
        Menu = 15
        SfondoMenu = 0
        Cursore = 15
        SfondoCursore = 0
        CarattereTX = 15
        rally = 0
        SfondoRally = 7
        Prova = 0
        SfondoProva = 7
        Conc = 15
        SfondoConc = 0
        Num = 0
        SfondoNum = 7
        Comm = 15
        SfondoComm = 5
        TitoliFoglio = 15
        Tempo = 0
        SfondoTempo = 7
        Comm = 0
        SfondoComm = 7
        Note = 0
        SfondoNote = 7
        Dom = 0
        SfondoDom = 7
        Errore = 0
        SfondoErrore = 7
        FileTit = 0
        SfondoTit = 7
        FileCurs = 0
        SfondoCurs = 7
        File = 15
        SfondoFile = 0
        Ombra = 0
        Aiuto = 15
        ora = 15
        Terminale = 7
        PremiTasto = 15
        Ingresso = 15
        Testo = 0
        SfondoTesto = 7
END IF

IF INSTR(COMMAND$, "/L") <> 0 THEN
        LOGGING = 0
END IF

IF INSTR(COMMAND$, "/I") <> 0 THEN
        AutoInit = 0
END IF

IF (INSTR(COMMAND$, "/?") <> 0) THEN
        GOSUB Istruzioni
        END
END IF

' -----------------------------------------------------------------------
' Se logging abilitato (default), apre il file di log
' -----------------------------------------------------------------------
IF LOGGING THEN
        ON ERROR GOTO GestioneErrori
        OPEN "GPCMDAT.LOG" FOR APPEND AS #5
        PRINT #5, ""
        PRINT #5, ""
        PRINT #5, STRING$(10, "*"); " File di log iniziato il "; DATE$; " alle ore "; TIME$
END IF

' -----------------------------------------------------------------------
' Porta seriale di default (COM1)
' -----------------------------------------------------------------------
COMPORT$ = COM1$ + BAUD$ + PARM$

' -----------------------------------------------------------------------
' Default in caso manchi il file GPCMDAT.INI
' -----------------------------------------------------------------------
I$(1) = "XXVI Rally Sprint del Carciofo"
I$(2) = "Paolino Paperino"
I$(3) = "I1PAP"
I$(4) = "1"
I$(5) = "N"
I$(6) = COMPORT$
I$(7) = "1"

' -----------------------------------------------------------------------
' Legge la configurazione
' -----------------------------------------------------------------------
LeggiConfig:
n = 1
ON ERROR GOTO NoConfig
OPEN "I", #2, "gpcmdat.ini"
WHILE NOT EOF(2)
        LINE INPUT #2, I$(n)
        n = n + 1
WEND
CLOSE #2
ON ERROR GOTO GestioneErrori
IF LOGGING THEN PRINT #5, STRING$(10, "*"); " Operatore: "; I$(2); " - Call: "; I$(3); " - PS: "; I$(4)


' -----------------------------------------------------------------------
' Se esiste la configurazione per porta seriale ed eco la utilizza
' -----------------------------------------------------------------------
IF I$(6) <> "" THEN
        COMPORT$ = I$(6)
        COMNUM = VAL(MID$(COMPORT$, 4, 1))
        BAUD$ = MID$(COMPORT$, 6, 5)
END IF
IF I$(7) <> "" THEN Echo = VAL(I$(7))

' -----------------------------------------------------------------------
' Prepara i comandi per il TNC (Standard TNC2)
' -----------------------------------------------------------------------
TNCCmds$(1) = "MYCALL " + I$(3)
TNCCmds$(2) = "ECHO OFF"
TNCCmds$(3) = "SENDPAC $01"
TNCCmds$(4) = "MONITOR OFF"
TNCCmds$(5) = "AUTOLF OFF"
TNCCmds$(6) = "PACLEN 255"
TNCCmds$(7) = "MAXFRAME 4"
TNCCmds$(8) = "PERSIST 248"
TNCCmds$(9) = "TXDELAY 40"
TNCCmds$(10) = "USERS 1"
TNCCmds$(11) = "FLOW OFF"
TNCCmds$(12) = "XFLOW ON"
TNCCmds$(13) = "AWLEN 8"
TNCCmds$(14) = "PARITY 0"
TNCCmds$(15) = "DAYUSA OFF"
TNCCmds$(16) = "CR ON"
TNCCmds$(17) = "STREAMSW $7C"
TNCCmds$(18) = "CONMODE CONVERSE"
TNCCmds$(19) = "AWLEN 8"
TNCCmds$(20) = "PARITY 0"
TNCCmds$(21) = "RESTART"                ' deve essere l'ultimo comando
NUMCMDS = 21

' -----------------------------------------------------------------------
' Definizione tasti funzione
' -----------------------------------------------------------------------
KEY 1, "CnfPrg"
KEY 2, "CmpMsg"
KEY 3, "VisFog"
KEY 4, "TxFogl"
KEY 5, LEFT$(COMPORT$, 4)
KEY 6, MID$(COMPORT$, 6, 4)
IF Echo = 1 THEN KEY 7, "Eco   " ELSE KEY 7, "NoEco "
KEY 8, "CnfTnc"
KEY 9, "Aiuto "
KEY 10, "Fine "

KEY(1) ON
KEY(2) ON
KEY(3) ON
KEY(4) ON
KEY(5) ON
KEY(6) ON
KEY(7) ON
KEY(8) ON
KEY(9) ON
KEY(10) ON
ON ERROR RESUME NEXT
KEY(31) ON
ON ERROR GOTO GestioneErrori

ON KEY(1) GOSUB ConfiguraProg
ON KEY(2) GOSUB CompilaFoglio
ON KEY(3) GOSUB VisualizzaFogli
ON KEY(4) GOSUB TrasmettiFoglio
ON KEY(5) GOSUB ScegliCOM
ON KEY(6) GOSUB ScegliBaud
ON KEY(7) GOSUB ScegliEco
ON KEY(8) GOSUB InizializzaTNC
ON KEY(9) GOSUB MostraAiuto
ON KEY(10) GOSUB FineProgramma
ON ERROR RESUME NEXT
ON KEY(31) GOSUB Informazioni
ON ERROR GOTO GestioneErrori

' -----------------------------------------------------------------------
' Definizione per intercettare il CONTROL-C
' -----------------------------------------------------------------------
KEY 15, CHR$(4) + CHR$(46)
KEY(15) ON
ON KEY(15) GOSUB CntrlC

' -----------------------------------------------------------------------
' Disegna la schermata iniziale
' -----------------------------------------------------------------------
VIEW PRINT 1 TO 25
COLOR Fronte, Sfondo
CLS
GOSUB DisegnaMaschera
GOSUB MostraOra
GOSUB Informazioni
COLOR Titolo, Sfondo
VIEW PRINT 1 TO 4
LOCATE 2, 25
COLOR Titolo, Sfondo
PRINT Versione$ + " - Trasmissione tempi "


' -----------------------------------------------------------------------
' Attiva linea menu tasti funzione
' -----------------------------------------------------------------------
COLOR Menu, SfondoMenu
KEY ON

' -----------------------------------------------------------------------
' Mostra il copyright per tre secondi
' -----------------------------------------------------------------------
T! = TIMER
WHILE TIMER - T! < 3: WEND

' -----------------------------------------------------------------------
' Mostra l'help, che lo vogliate o no
' -----------------------------------------------------------------------
GOSUB StampaAiuto

' -----------------------------------------------------------------------
' Apertura porta seriale e inizializzazione TNC
' -----------------------------------------------------------------------
GOSUB ApriCom
IF AutoInit = 1 THEN
        GOSUB InizializzaTNC
END IF
' -----------------------------------------------------------------------
' Attiva il timer
' -----------------------------------------------------------------------
TIMER ON
ON TIMER(1) GOSUB MostraOra

' -----------------------------------------------------------------------
' Loop di trasmissione del terminale.
' Il programma continua a girare qui se non interrotto da altri eventi
' come l'arrivo di caratteri dalla seriale, lo scadere del timer o la
' pressione di un tasto funzione.
' -----------------------------------------------------------------------
DO UNTIL FineProgramma
        EVENT OFF
        VIEW PRINT 19 TO 23
        OldTop = 19
        OldBottom = 23
        COLOR Cursore, SfondoCursore
        LOCATE TermRow, TermCol
        PRINT CHR$(219);
        LOCATE TermRow, TermCol
        EVENT ON
        DO
                Tx$ = INKEY$
        LOOP UNTIL Tx$ <> ""
        EVENT OFF
        VIEW PRINT 19 TO 23
        LOCATE TermRow, TermCol
        COLOR Cursore, Sfondo
        PRINT " ";
        LOCATE TermRow, TermCol
        IF Echo = 1 AND (ASC(Tx$) > 31 OR ASC(Tx$) = 13) THEN
                EVENT OFF
                VIEW PRINT 19 TO 23
                LOCATE TermRow, TermCol
                COLOR CarattereTX, Sfondo
                PRINT Tx$;
                TermRow = CSRLIN
                TermCol = POS(0)
                EVENT ON
        END IF
        PRINT #1, Tx$;
        IF LOGGING THEN PRINT #5, Tx$;
        EVENT ON
LOOP

' ===========================< Gestione F-key >==========================

' -----------------------------------------------------------------------
' Configurazione programma (F1)
' -----------------------------------------------------------------------
ConfiguraProg:
        EVENT OFF
        VIEW PRINT 1 TO 3
        LOCATE 2, 13
        COLOR Titolo, Sfondo
        PRINT SPACE$(58)
        LOCATE 2, 22
        COLOR Titolo, Sfondo
        PRINT Versione$; " - Configurazione programma";
        VIEW PRINT 4 TO 17
        OldTop = 4
        OldBottom = 17
        EVENT ON
        GOSUB DisabilitaFKey
        COLOR Fronte, Sfondo
        CLS (2)
        n = 1
        ON ERROR GOTO NoConfig
        OPEN "I", #3, "gpcmdat.ini"
        WHILE NOT EOF(3)
                LINE INPUT #3, I$(n)
                n = n + 1
        WEND
        CLOSE #3
        ON ERROR GOTO NoFoglio
        OPEN "I", #3, "NuFoglio.txt"
        LINE INPUT #3, f$
        nfog = VAL(LTRIM$(f$))
        CLOSE #3
        ON ERROR GOTO GestioneErrori
        LOCATE 4, 4: PRINT "Nome manifestazione..................: "; I$(1)
        LOCATE 6, 4: PRINT "Nome e Cognome operatore.............: "; I$(2)
        LOCATE 7, 4: PRINT "Call operatore.......................: "; I$(3)
        LOCATE 8, 4: PRINT "Posizione operatore (numero P.S.)....: "; I$(4)
        LOCATE 9, 4: PRINT "Numero foglio iniziale..............: "; nfog;
        LOCATE 11, 4: PRINT "Data.................................: "; MID$(DATE$, 4, 2); "/"; LEFT$(DATE$, 2); "/"; RIGHT$(DATE$, 4);
        LOCATE 12, 4: PRINT "Ora..................................: "; TIME$
        LOCATE 14, 4: PRINT "Formato dati.........................: ";
        Form$ = UCASE$(I$(5))
        IF Form$ = "S" THEN
                PRINT "mm.ss"
        ELSE
                IF Form$ = "D" THEN
                        PRINT "mm.ss.d"
                ELSE
                        PRINT "mm.ss.cc"
                END IF
        END IF
        LOCATE 16, 4
        COLOR Dom, SfondoDom
        PRINT "Confermi dati (S/N) ";
        CALL StrLget(scelta$, "S", 1, 2, Dom, SfondoDom)
        IF UCASE$(scelta$) <> "S" AND scelta$ <> "" AND scelta$ <> CHR$(27) THEN
                GOSUB Configura
        END IF
        GOSUB MostraAiuto
        GOSUB AbilitaFKey
RETURN

' -----------------------------------------------------------------------
' Inizio configurazione programma
' -----------------------------------------------------------------------
Configura:
        EVENT OFF
        VIEW PRINT 4 TO 17
        OldTop = 4
        OldBottom = 17
        EVENT ON
        GOSUB DisabilitaFKey
        COLOR FronteHi, Sfondo
        CLS (2)
        LOCATE 4, 4: PRINT "Nome manifestazione..................: ";
        LOCATE 6, 4: PRINT "Nome e Cognome operatore.............: ";
        LOCATE 7, 4: PRINT "Call operatore.......................: ";
        LOCATE 8, 4: PRINT "Posizione operatore (numero P.S.)....: ";
        LOCATE 9, 4: PRINT "Numero foglio iniziale...............: ";
        LOCATE 11, 4: PRINT "Data................................: ";
        LOCATE 12, 4: PRINT "Ora.................................: ";
        LOCATE 14, 4: PRINT "Secondi, Decimi o Centesimi.(S/D/C).: ";

rally:
        LOCATE 4, 43
        CALL StrLget(tmp$, I$(1), 33, 0, Sfondo, Ingresso)
        IF (tmp$ <> "") AND (tmp$ <> CHR$(27)) THEN
                I$(1) = tmp$
        ELSE
                PRINT I$(1)
                IF tmp$ = CHR$(27) THEN GOTO esci
        END IF

nome:
        LOCATE 6, 43
        CALL StrLget(tmp$, I$(2), 33, 0, Sfondo, Ingresso)
        IF (tmp$ <> "") AND (LEFT$(tmp$, 1) <> CHR$(27)) THEN
                I$(2) = tmp$
        ELSE
                PRINT I$(2)
                IF tmp$ = CHR$(27) THEN GOTO rally

        END IF

nominativo:
        LOCATE 7, 43
        CALL StrLget(tmp$, I$(3), 9, 0, Sfondo, Ingresso)
        IF (tmp$ <> "") AND (tmp$ <> CHR$(27)) THEN
                I$(3) = tmp$
        ELSE
                PRINT I$(3)
                IF tmp$ = CHR$(27) THEN GOTO nome

        END IF

ps:
        LOCATE 8, 43
        CALL StrLget(tmp$, I$(4), 2, 1, Sfondo, Ingresso)
        IF (tmp$ <> "") AND (tmp$ <> CHR$(27)) THEN
                I$(4) = tmp$
        ELSE
                PRINT I$(4)
                IF tmp$ = CHR$(27) THEN GOTO nominativo
        END IF

foglio:
        LOCATE 9, 43
        nf$ = LTRIM$(STR$(nfog))
        PRINT nf$;
        LOCATE 9, 43
        CALL StrLget(tmp$, nf$, 2, 1, Sfondo, Ingresso)
        IF (tmp$ <> "") AND (tmp$ <> CHR$(27)) THEN
                nfog = VAL(tmp$)
                OPEN "O", #3, "NuFoglio.txt"
                PRINT #3, tmp$
                CLOSE #3
        ELSE
                PRINT nf$
                IF tmp$ = CHR$(27) THEN GOTO ps
        END IF

        LOCATE 9, 43
        PRINT tmp$;

        gg$ = MID$(DATE$, 4, 2)
        mm$ = LEFT$(DATE$, 2)
        aa$ = RIGHT$(DATE$, 4)

gg:
        LOCATE 11, 43
        PRINT gg$; "/"; mm$; "/"; aa$;
        LOCATE 11, 43
        CALL StrLget(tmp$, gg$, 2, 1, Sfondo, Ingresso)
        IF tmp$ = CHR$(27) THEN
                LOCATE 11, 43
                PRINT ; gg$; "/"; mm$; "/"; aa$;
                GOTO foglio:
        END IF
        gg$ = tmp$

mm:
        LOCATE 11, 43
        PRINT ; gg$; "/"; mm$; "/"; aa$;
        LOCATE 11, 46
        CALL StrLget(tmp$, mm$, 2, 1, Sfondo, Ingresso)
        IF tmp$ = CHR$(27) THEN GOTO gg:
        mm$ = tmp$

aa:
        LOCATE 11, 43
        PRINT ; gg$; "/"; mm$; "/"; aa$;
        LOCATE 11, 49
        CALL StrLget(tmp$, aa$, 4, 1, Sfondo, Ingresso)
        IF tmp$ = CHR$(27) THEN GOTO mm:
        aa$ = tmp$

        ore$ = LEFT$(TIME$, 2)
        min$ = MID$(TIME$, 4, 2)
        sec$ = RIGHT$(TIME$, 2)
ore:
        LOCATE 12, 43
        PRINT ore$; ":"; min$; ":"; sec$;
        LOCATE 12, 43
        CALL StrLget(tmp$, ore$, 2, 1, Sfondo, Ingresso)
        IF tmp$ = CHR$(27) THEN
                LOCATE 12, 43
                PRINT ore$; ":"; min$; ":"; sec$; ;
                GOTO aa:
        END IF
        ore$ = tmp$

min:
        LOCATE 12, 43
        PRINT ore$; ":"; min$; ":"; sec$;
        LOCATE 12, 46
        CALL StrLget(tmp$, min$, 2, 1, Sfondo, Ingresso)
        IF tmp$ = CHR$(27) THEN GOTO ore:
        min$ = tmp$

sec:
        LOCATE 12, 43
        PRINT ore$; ":"; min$; ":"; sec$;
        LOCATE 12, 49
        CALL StrLget(tmp$, sec$, 2, 1, Sfondo, Ingresso)
        IF tmp$ = CHR$(27) THEN GOTO min:
        sec$ = tmp$

decimi:
        LOCATE 14, 43
        CALL StrLget(tmp$, I$(5), 1, 3, Sfondo, Ingresso)
        IF (tmp$ <> "") AND (tmp$ <> CHR$(27)) THEN
                I$(5) = tmp$
        ELSE
                PRINT I$(5)
                IF tmp$ = CHR$(27) THEN GOTO sec
        END IF

        LOCATE 16, 4
        COLOR Dom, SfondoDom
        PRINT "Confermi dati (S/N) ";
        CALL StrLget(tmp$, "N", 1, 2, Dom, SfondoDom)
        IF UCASE$(tmp$) <> "S" THEN
                IF tmp$ = CHR$(27) THEN GOTO decimi
                GOTO Configura
        END IF
        DATE$ = mm$ + "-" + gg$ + "-" + aa$
        TIME$ = ore$ + ":" + min$ + ":" + sec$
        TNCCmds$(1) = "MYCALL " + I$(3)
        GOSUB SalvaINI
esci:
RETURN

' -----------------------------------------------------------------------
' Compila un nuovo foglio (F2)
' -----------------------------------------------------------------------
CompilaFoglio:
        EVENT OFF
        VIEW PRINT 1 TO 3
        COLOR Titolo, Sfondo
        LOCATE 2, 13
        PRINT SPACE$(58)
        LOCATE 2, 22
        PRINT Versione$; " - Composizione messaggio"; :
        COLOR Fronte, Sfondo
        VIEW PRINT 4 TO 17
        OldTop = 4
        OldBottom = 17
        EVENT ON
        GOSUB DisabilitaFKey

LeggiNumFoglio:
        CLS (2)
        ON ERROR GOTO NoFoglio
        OPEN "I", #3, "NuFoglio.txt"
        LINE INPUT #3, f$
        nfog = VAL(LTRIM$(f$))
        CLOSE #3
        ON ERROR GOTO GestioneErrori
        '
        ' Visualizzazione dati fissi
        '
        lint = LEN(I$(1))
        posint = INT((80 - lint) / 2)
        LOCATE 4, posint
        COLOR rally, SfondoRally
        PRINT I$(1)
        LOCATE 5, 5
        COLOR Fronte, Sfondo
        PRINT "Prova: ";
        COLOR Prova, SfondoProva
        PRINT I$(4);
        LOCATE 5, 28
        COLOR Fronte, Sfondo
        PRINT "Data: ";
        COLOR Prova, SfondoProva
        PRINT MID$(DATE$, 4, 2); "/"; LEFT$(DATE$, 2); "/"; RIGHT$(DATE$, 4);
        COLOR Fronte, Sfondo
        PRINT " Ora:";
        COLOR Prova, SfondoProva
        PRINT TIME$;
        LOCATE 5, 63
        COLOR Fronte, Sfondo
        PRINT "Foglio n.:";
        COLOR Prova, SfondoProva
        PRINT LTRIM$(STR$(nfog))
        '
        ' Costruzione Maschera
        '
        LOCATE 7, 5
        COLOR Conc, SfondoConc
        PRINT SPACE$(71)
        LOCATE 7, 6
        COLOR TitoliFoglio, Sfondo
        PRINT "Concorrente";
        LOCATE 7, 21
        PRINT "Tempo";
        LOCATE 7, 35
        PRINT "Commenti";
        LOCATE 7, 61
        PRINT "(    caratteri)";
        COLOR Fronte, Sfondo
        LOCATE 8, 5: PRINT STRING$(71, CHR$(205))
        '
        ' Inserimento dati variabili
        '
        nrig = 9
        DollaroN = 0
        Lun = 14 + LEN(I$(4)) + LEN(STR$(nfog))
        LOCATE 7, 62:
        COLOR TitoliFoglio, Sfondo
        PRINT USING "###"; Lun
        scelta$ = ""
        FOR I = 1 TO 5
                 Conco$(I) = ""
                 MINU$(I) = ""
                 Seco$(I) = ""
                 Deci$(I) = ""
                 Comm$(I) = ""
        NEXT
        Note$(1) = ""
        Note$(2) = ""
        FOR I = 1 TO 5
Conco:
                DO
                        LOCATE nrig, 9:
                        CALL StrLget(Conco$(I), "", 5, 1, Num, SfondoNum)
                LOOP UNTIL Conco$(I) <> "" OR I > 1 OR Conco$(I) = CHR$(27)
                IF Conco$(I) = CHR$(27) THEN
                        IF I = 1 THEN
                                GOSUB MostraAiuto
                                GOSUB AbilitaFKey
                                RETURN
                        ELSE
                                I = I - 1
                                nrig = nrig - 1
                                GOTO Comm
                        END IF
                END IF
                IF Conco$(I) = "" AND I > 1 THEN
                        LOCATE nrig, 1
                        COLOR Sfondo, Sfondo
                        PRINT SPACE$(60);
                        nrig = 14
                        DollaroN = 1
                        EXIT FOR
                END IF
                Lun = Lun + LEN(Conco$(I)) + 3
                LOCATE 7, 62:
                COLOR TitoliFoglio, Sfondo
                PRINT USING "###"; Lun
                IF Lun >= 240 THEN PLAY ("l30 N35")
MINU:
                DO
                        COLOR Tempo, SfondoTempo
                        LOCATE nrig, 21
                        CALL StrLget(MINU$(I), "", 2, 1, Tempo, SfondoTempo)
                LOOP UNTIL VAL(MINU$(I)) >= 0 OR MINU$(I) = CHR$(27)
                IF MINU$(I) = CHR$(27) THEN GOTO Conco
                IF MINU$(I) = "" THEN MINU$(I) = "00"
                IF LEN(MINU$(I)) = 1 THEN MINU$(I) = "0" + MINU$(I)
                LOCATE nrig, 21
                COLOR Tempo, SfondoTempo
                PRINT MINU$(I);
                Lun = Lun + LEN(MINU$(I))
                LOCATE 7, 62
                COLOR TitoliFoglio, Sfondo
                PRINT USING "###"; Lun
                IF Lun >= 240 THEN PLAY ("l30 N35")
                COLOR Fronte, Sfondo
                LOCATE nrig, 23: PRINT ".";
Seco:
                DO
                        COLOR Tempo, SfondoTempo
                        LOCATE nrig, 24
                        CALL StrLget(Seco$(I), "", 2, 1, Tempo, SfondoTempo)
                LOOP UNTIL VAL(Seco$(I)) >= 0 OR Seco$(I) = CHR$(27)
                IF Seco$(I) = CHR$(27) THEN GOTO MINU
                IF Seco$(I) = "" THEN Seco$(I) = "00"
                IF LEN(Seco$(I)) = 1 THEN Seco$(I) = "0" + Seco$(I)
                LOCATE nrig, 24
                COLOR Tempo, SfondoTempo
                PRINT Seco$(I);
                Lun = Lun + LEN(Seco$(I)) + 1
                LOCATE 7, 62
                COLOR TitoliFoglio, Sfondo
                PRINT USING "###"; Lun
                IF Lun >= 240 THEN PLAY ("l30 N35")
Deci:
                Form$ = UCASE$(I$(5))
                IF Form$ = "D" OR Form$ = "C" THEN
                        COLOR Fronte, Sfondo
                        LOCATE nrig, 26
                        PRINT ".";
                        DO
                                COLOR Tempo, SfondoTempo
                                LOCATE nrig, 27
                                IF Form$ = "D" THEN
                                        CALL StrLget(Deci$(I), "", 1, 1, Tempo, SfondoTempo)
                                ELSE
                                        CALL StrLget(Deci$(I), "", 2, 1, Tempo, SfondoTempo)
                                END IF
                        LOOP UNTIL VAL(Deci$(I)) >= 0 OR Deci$(I) = CHR$(27)
                        IF Deci$(I) = CHR$(27) THEN GOTO Seco
                        IF Form$ = "D" THEN
                                IF Deci$(I) = "" THEN Deci$(I) = "0"
                        END IF
                        IF Form$ = "C" THEN
                                IF Deci$(I) = "" THEN Deci$(I) = "00"
                                IF LEN(Deci$(I)) = 1 THEN Deci$(I) = "0" + Deci$(I)
                        END IF
                        LOCATE nrig, 27
                        COLOR Tempo, SfondoTempo
                        PRINT Deci$(I);
                        Lun = Lun + LEN(Deci$(I)) + 1
                        LOCATE 7, 62
                        COLOR TitoliFoglio, Sfondo
                        PRINT USING "###"; Lun
                        IF Lun >= 240 THEN PLAY ("l30 N35")
                END IF
Comm:
                LOCATE nrig, 35
                CALL StrLget(Comm$(I), "", 20, 0, Comm, SfondoComm)
                IF Comm$(I) = CHR$(27) THEN
                        IF UCASE$(I$(5)) = "S" THEN
                                GOTO Seco
                        ELSE
                                GOTO Deci
                        END IF
                END IF
                Lun = Lun + LEN(Comm$(I)) + 2
                IF Comm$(I) <> "" THEN Lun = Lun + 3
                LOCATE 7, 62
                COLOR TitoliFoglio, Sfondo
                PRINT USING "###"; Lun
                IF Lun >= 240 THEN PLAY ("l30 N35")
                nrig = nrig + 1
        NEXT
Note1:
        COLOR Fronte, Sfondo
        LOCATE nrig, 5
        PRINT "Note (riga 1):";
        DO
                COLOR Note, SfondoNote
                LOCATE nrig, 18
                CALL StrLget(Note$(1), "", 37, 0, Note, SfondoNote)
        LOOP UNTIL Note$(1) <> CHR$(27)
        IF Note$(1) = "" THEN
                LOCATE nrig, 1
                COLOR Sfondo, Sfondo
                PRINT SPACE$(60);
                GOTO NoNote
        END IF
        Lun = Lun + LEN(Note$(1))
        IF Note$(1) <> "" THEN
                IF DollaroN THEN Lun = Lun + 6 ELSE Lun = Lun + 2
        END IF
Note2:
        LOCATE 7, 62
        COLOR TitoliFoglio, Sfondo
        PRINT USING "###"; Lun
        IF Lun >= 240 THEN PLAY ("l30 N35")
        nrig = nrig + 1
        COLOR Fronte, Sfondo
        LOCATE nrig, 5
        PRINT "Note (riga 2)";
        COLOR Note, SfondoNote
        LOCATE nrig, 18
        CALL StrLget(Note$(2), "", 37, 0, Note, SfondoNote)
        IF Note$(2) = CHR$(27) THEN
                nrig = nrig - 1
                GOTO Note1
        END IF
        Lun = Lun + LEN(Note$(2))
        IF Note$(2) <> "" THEN Lun = Lun + 2
        LOCATE 7, 62
        COLOR TitoliFoglio, Sfondo
        PRINT USING "###"; Lun
        IF Lun >= 240 THEN PLAY ("l30 N35")
NoNote:
        LOCATE 17, 5
        COLOR Dom, SfondoDom
        PRINT "Confermi S/N:";
        DO
                CALL StrLget(scelta$, "S", 1, 2, Dom, SfondoDom)
                scelta$ = UCASE$(scelta$)
        LOOP UNTIL scelta$ = "S" OR scelta$ = "N" OR scelta$ = ""
        
        IF scelta$ = "S" OR scelta$ = "" THEN
                FOR n = 1 TO 11
                        Stampa$(n) = ""
                NEXT
                decimi = (UCASE$(I$(5)) <> "N")
                Stampa$(1) = "$T"
                Stampa$(2) = "PS " + I$(4) + " " + "F" + STR$(nfog)
                NumTempi = 0
                FOR I = 1 TO 5
                        IF Conco$(I) <> "" THEN
                                NumTempi = NumTempi + 1
                                Stampa$(I + 2) = Conco$(I) + SPACE$(3) + MINU$(I) + "." + Seco$(I)
                                IF decimi THEN
                                        Stampa$(I + 2) = Stampa$(I + 2) + "." + Deci$(I)
                                END IF
                                IF Comm$(I) <> "" THEN
                                        Stampa$(I + 2) = Stampa$(I + 2) + SPACE$(3) + Comm$(I)
                                END IF
                        END IF
                NEXT
                IF Note$(1) <> "" OR Note$(2) <> "" THEN
                        IF NumTempi = 5 THEN
                                Stampa$(8) = Note$(1)
                                Stampa$(9) = Note$(2)
                                Stampa$(10) = CHR$(1)
                                nrec = 10
                        ELSE
                                Stampa$(8) = "$N"
                                Stampa$(9) = Note$(1)
                                Stampa$(10) = Note$(2)
                                Stampa$(11) = CHR$(1)
                                nrec = 11
                        END IF
                ELSE
                        Stampa$(8) = CHR$(1)
                        nrec = 8
                END IF
                OPEN "O", #4, "PS" + I$(4) + "FO" + LTRIM$(STR$(nfog)) + ".txt"
                FOR ciclo = 1 TO nrec
                        IF Stampa$(ciclo) <> "" THEN
                                PRINT #4, Stampa$(ciclo)
                        END IF
                NEXT
                CLOSE #4
                OPEN "O", #3, "NuFoglio.txt"
                PRINT #3, LTRIM$(STR$(nfog + 1))
                CLOSE #3
                LOCATE 17, 25
                COLOR Dom, SfondoDom
                PRINT "Trasmetto il foglio S/N:";
                DO
                        CALL StrLget(scelta$, "S", 1, 2, Dom, SfondoDom)
                        scelta$ = UCASE$(scelta$)
                LOOP UNTIL scelta$ = "S" OR scelta$ = "N" OR scelta$ = ""
                
                IF scelta$ = "S" OR scelta$ = "" THEN
                        GOSUB TrasmettiFoglio
                END IF
        END IF
        LOCATE 17, 55
        COLOR Dom, SfondoDom
        PRINT "Altro foglio S/N:";
        DO
                CALL StrLget(scelta$, "S", 1, 2, Dom, SfondoDom)
                scelta$ = UCASE$(scelta$)
        LOOP UNTIL scelta$ = "S" OR scelta$ = "N" OR scelta$ = ""
                
        IF scelta$ = "S" OR scelta$ = "" THEN
                        GOTO CompilaFoglio
        ELSE
                GOSUB MostraAiuto
                GOSUB AbilitaFKey
                RETURN
        END IF
RETURN

' -----------------------------------------------------------------------
' Visualizzazione/caricamento/editing/cancellazione fogli trasmessi (F3)
' -----------------------------------------------------------------------
VisualizzaFogli:
        EVENT OFF
        VIEW PRINT 1 TO 3
        COLOR Titolo, Sfondo
        LOCATE 2, 13
        PRINT SPACE$(58)
        LOCATE 2, 20
        Titolo$ = Versione$ + " - Visualizzazione/edit fogli"
        PRINT Titolo$
        VIEW PRINT 4 TO 17
        OldTop = 4
        OldBottom = 17
        EVENT ON
        GOSUB DisabilitaFKey
        KEY(4) ON
        CLS (2)
        LOCATE 4, 1
        NumFile = 0
        f$ = DIR$("PS*.txt")
        IF f$ <> "" THEN
                NumFile = NumFile + 1
                Fogli$(NumFile) = f$
                DO
                        f$ = DIR$
                        IF f$ <> "" THEN
                                NumFile = NumFile + 1
                                Fogli$(NumFile) = f$
                        END IF
                LOOP UNTIL f$ = ""
        END IF

        IF NumFile = 0 THEN
                COLOR Errore, SfondoErrore
                LOCATE 9, 25
                PRINT "                               "
                LOCATE 10, 25
                PRINT "    Non c' nessun foglio!     "
                LOCATE 11, 25
                PRINT " Premi un tasto per proseguire "
                LOCATE 12, 25
                PRINT "                               "
                a$ = INPUT$(1)
                GOSUB MostraAiuto
                GOSUB AbilitaFKey
                RETURN
        END IF

        GOSUB SortFogli

        LOCATE 4, 2
        COLOR FileTit, SfondoTit
        PRINT " Fogli disp. "
        LOCATE 17, 15
        COLOR FileTit, SfondoTit
        PRINT " "; CHR$(24); CHR$(25); "=Scegli INVIO=Carica INS=Edit DEL=Canc. F4=Tx ESC o FINE=Fine ";

        start = 1
        filep = 1
        IF NumFile > 13 THEN Max = 13 ELSE Max = NumFile
        DO
                C$ = INKEY$
                IF LEN(C$) = 2 AND LEFT$(C$, 1) = CHR$(0) THEN
                        IF RIGHT$(C$, 1) = CHR$(80) THEN
                                filep = filep + 1
                                IF filep > Max THEN
                                        filep = Max
                                        start = start + 1
                                        IF start > NumFile - Max + 1 THEN start = start - 1
                                END IF
                        END IF
                        IF RIGHT$(C$, 1) = CHR$(72) THEN
                                filep = filep - 1
                                IF filep < 1 THEN
                                        filep = 1
                                        start = start - 1
                                        IF start < 1 THEN start = 1
                                END IF
                        END IF
                        IF RIGHT$(C$, 1) = CHR$(83) THEN
                                LOCATE 16, 25
                                COLOR Errore, SfondoErrore
                                PRINT " Sei sicuro di voler cancellare '"; Fogli$(start + filep - 1); "'? ";
                                CALL StrLget(a$, "N", 1, 2, Errore, SfondoErrore)
                                LOCATE 16, 25
                                COLOR Sfondo, Sfondo
                                PRINT SPACE$(45)
                                IF UCASE$(a$) = "S" THEN
                                        KILL Fogli$(start + filep - 1)
                                        OPEN "I", #3, "NuFoglio.txt"
                                        LINE INPUT #3, f$
                                        nfog = VAL(LTRIM$(f$)) - 1
                                        IF nfog < 1 THEN nfog = 1
                                        CLOSE #3
                                        OPEN "O", #3, "NuFoglio.txt"
                                        PRINT #3, STR$(nfog)
                                        CLOSE #3
                                        NumFile = NumFile - 1
                                        IF NumFile <= 0 THEN
                                                NumFile = 0
                                                GOSUB MostraAiuto
                                                GOSUB AbilitaFKey
                                                RETURN
                                        END IF
                                        FOR I = start + filep - 1 TO start + NumFile - 1
                                                Fogli$(I) = Fogli$(I + 1)
                                        NEXT
                                        FOR I = 1 TO 12
                                                COLOR Sfondo, Sfondo
                                                LOCATE 3 + I, 23
                                                PRINT SPACE$(40)
                                        NEXT
                                        start = start - 1
                                        IF start < 1 THEN start = 1
                                        IF NumFile < Max THEN Max = NumFile
                                        IF filep > Max THEN filep = Max
                                END IF
                        END IF
                        IF RIGHT$(C$, 1) = CHR$(82) THEN
                                Editing = 1
                                GOSUB VisualFoglio
                                GOSUB Edit
                        END IF
                END IF
                COLOR Testo, SfondoTesto
                IF C$ = CHR$(13) THEN
                        Editing = 0
                        GOSUB VisualFoglio
                END IF
                FOR R = start TO start + 12
                        LOCATE R - start + 5, 2
                        IF R - start + 1 = filep THEN
                                COLOR FileCurs, SfondoCurs
                        ELSE
                                COLOR File, SfondoFile
                        END IF
                        IF R <= NumFile THEN
                                PRINT LEFT$(Fogli$(R) + "             ", 13);
                        ELSE
                                PRINT "             ";
                        END IF
                NEXT

        LOOP UNTIL (LEN(C$) = 2 AND RIGHT$(C$, 1) = CHR$(79)) OR C$ = CHR$(27)
        GOSUB MostraAiuto
        GOSUB AbilitaFKey
RETURN

' -----------------------------------------------------------------------
' Trasmette il foglio in Stampa$ (F4)
' -----------------------------------------------------------------------
TrasmettiFoglio:
        EVENT OFF
        OldRow = CSRLIN
        OldCol = POS(0)
        VIEW PRINT 1 TO 3
        COLOR Titolo, Sfondo
        LOCATE 2, 13
        PRINT SPACE$(58)
        LOCATE 2, 22
        PRINT Versione$; " - Trasmetti foglio corrente "; :
        COLOR CarattereTX, Sfondo
        VIEW PRINT 19 TO 23
        LOCATE TermRow, TermCol
        IF nrec <> 0 THEN
                FOR ciclo = 1 TO nrec
                        IF Stampa$(ciclo) <> "" THEN
                                PRINT #1, Stampa$(ciclo)
                                PRINT Stampa$(ciclo)
                        END IF
                NEXT ciclo
                IF LOGGING THEN
                        PRINT #5, "Foglio '"; Stampa$(2); "' trasmesso in data "; DATE$; " alle ore "; TIME$
                END IF
        END IF
        TermRow = CSRLIN
        TermCol = POS(0)
        VIEW PRINT 1 TO 3
        COLOR Titolo, Sfondo
        LOCATE 2, 13
        PRINT SPACE$(58)
        LOCATE 2, 22
        PRINT Titolo$
        VIEW PRINT OldTop TO OldBottom
        LOCATE OldRow, OldCol
        EVENT ON
RETURN

' -----------------------------------------------------------------------
' Seleziona la porta seriale (F5)
' -----------------------------------------------------------------------
ScegliCOM:
        COLOR Menu, SfondoMenu
        COM(COMNUM) OFF
        CLOSE #1
        IF COMNUM = 1 THEN
                COMNUM = 2
                COMPORT$ = COM2$ + BAUD$ + PARM$
                KEY 5, "COM2 "
        ELSE
                COMNUM = 1
                COMPORT$ = COM1$ + BAUD$ + PARM$
                KEY 5, "COM1"
        END IF
        GOSUB ApriCom
        I$(6) = COMPORT$
        GOSUB SalvaINI
RETURN

' -----------------------------------------------------------------------
' Seleziona il baud rate (F6)
' -----------------------------------------------------------------------
ScegliBaud:
        COLOR Menu, SfondoMenu
        COM(COMNUM) OFF
        CLOSE #1
        SELECT CASE BAUD$
                CASE "1200,"
                        BAUD$ = "2400,"
                        KEY 6, "2400"
                CASE "2400,"
                        BAUD$ = "4800,"
                        KEY 6, "4800"
                CASE "4800,"
                        BAUD$ = "9600,"
                        KEY 6, "9600"
                CASE "9600,"
                        BAUD$ = "1200,"
                        KEY 6, "1200"
        END SELECT
        IF COMNUM = 1 THEN
                COMPORT$ = COM1$ + BAUD$ + PARM$
        ELSE
                COMPORT$ = COM2$ + BAUD$ + PARM$
        END IF
        GOSUB ApriCom
        I$(6) = COMPORT$
        GOSUB SalvaINI
RETURN

' -----------------------------------------------------------------------
' Attiva/disattiva l'eco locale (F7)
' -----------------------------------------------------------------------
ScegliEco:
        EVENT OFF
        COLOR Menu, SfondoMenu
        IF Echo = 1 THEN
                Echo = 0
                KEY 7, "NoEco"
        ELSE
                Echo = 1
                KEY 7, "Eco"
        END IF
        I$(7) = LTRIM$(STR$(Echo))
        GOSUB SalvaINI
        EVENT ON
RETURN

' -----------------------------------------------------------------------
' Inzializza TNC (F8)
' -----------------------------------------------------------------------
InizializzaTNC:
        EVENT OFF
        OldRow = CSRLIN
        OldCol = POS(0)
        VIEW PRINT 1 TO 3
        COLOR Titolo, Sfondo
        LOCATE 2, 13
        PRINT SPACE$(58)
        LOCATE 2, 26
        PRINT Versione$; " - Configurazione TNC";
        VIEW PRINT 19 TO 23
        LOCATE TermRow, TermCol
        COLOR Cursore, Sfondo
        PRINT " ";
        LOCATE TermRow, TermCol
        COLOR CarattereTX, Sfondo
        '
        ' Fa uscire il TNC dal modo KISS
        '
        IF Echo = 1 THEN PRINT : PRINT "Disabilitazione modo KISS..."
        PRINT #1, ""
        PRINT #1, CHR$(192);
        PRINT #1, CHR$(255);
        PRINT #1, CHR$(192);
        T! = TIMER
        WHILE TIMER - T! < 1: WEND
        '
        ' Fa uscire il TNC dal modo trasparente
        '
        IF Echo = 1 THEN PRINT "Disabilitazione modo TRASPARENTE..."
        PRINT #1, ""
        T! = TIMER
        WHILE TIMER - T! < 2: WEND
        PRINT #1, CHR$(3);
        PRINT #1, CHR$(3);
        PRINT #1, CHR$(3);
        T! = TIMER
        WHILE TIMER - T! < 2: WEND
        '
        ' Configurazione TNC
        '
        IF Echo = 1 THEN PRINT "Configurazione del TNC..."
        PRINT #1, ""
        FOR n = 1 TO NUMCMDS
                PRINT #1, TNCCmds$(n)
                IF Echo = 1 THEN PRINT TNCCmds$(n)
                T! = TIMER
                WHILE TIMER - T! < .25: WEND
        NEXT
        '
        ' Aspetta il completamento del restart
        '
        T! = TIMER
        WHILE TIMER - T! < 2: WEND
        '
        ' Set orologio del TNC
        '
        DT$ = DATE$     ' Prende data dal Pc
        tm$ = TIME$     ' Prende ora dal Pc
        ti$ = "DAYTIME " + RIGHT$(DT$, 2) + LEFT$(DT$, 2) + MID$(DT$, 4, 2) + LEFT$(tm$, 2) + MID$(tm$, 4, 2)
        PRINT #1, ti$
        IF Echo = 1 THEN PRINT ti$
        TermRow = CSRLIN
        TermCol = POS(0)
        LOCATE TermRow, TermCol
        COLOR Cursore, SfondoCursore
        PRINT " ";
        VIEW PRINT 1 TO 3
        COLOR Titolo, Sfondo
        LOCATE 2, 13
        PRINT SPACE$(58)
        LOCATE 2, 22
        PRINT Versione$; " - Mini Terminale ed Aiuto";
        VIEW PRINT OldTop TO OldBottom
        IF OldRow < 19 THEN
                LOCATE OldRow, OldCol
        ELSE
                LOCATE TermRow, TermCol
        END IF
        EVENT ON
RETURN

' -----------------------------------------------------------------------
' Mostra l'help (F9)
' -----------------------------------------------------------------------
MostraAiuto:
        EVENT OFF
        GOSUB StampaAiuto
        VIEW PRINT OldTop TO OldBottom
        EVENT ON
RETURN

' -----------------------------------------------------------------------
' Fine programma (F10)
' -----------------------------------------------------------------------
FineProgramma:
        EVENT OFF
        GOSUB DisabilitaFKey
        VIEW PRINT 4 TO 17
        OldTop = 4
        OldBottom = 17
        EVENT ON
        COLOR Fronte, Sfondo
        CLS (2)
        COLOR Errore, SfondoErrore
        LOCATE 10, 24
        PRINT SPACE$(32)
        LOCATE 11, 24
        PRINT SPACE$(32)
        LOCATE 12, 24
        PRINT SPACE$(32)
        DO
                LOCATE 11, 24
                COLOR Errore, SfondoErrore
                PRINT " Vuoi veramente uscire (S/N)? ";
                LOCATE 11, 54
                CALL StrLget(f$, "N", 1, 2, Errore, SfondoErrore)
                f$ = UCASE$(f$)
        LOOP UNTIL f$ = "S" OR f$ = "N" OR f$ = ""
        IF f$ = "S" THEN
                VIEW PRINT 1 TO 24
                KEY OFF
                COLOR 7, 0
                CLS
                SYSTEM
        END IF
        GOSUB MostraAiuto
        GOSUB AbilitaFKey
RETURN

' -----------------------------------------------------------------------
' Mostra la finestra del copyright (F12)
' -----------------------------------------------------------------------
Informazioni:
        EVENT OFF
        OldRow = CSRLIN
        OldCol = POS(0)
        VIEW PRINT 4 TO 17
        OldTop = 4
        OldBottom = 17
        CLS (2)
        COLOR Errore, SfondoErrore
        LOCATE 7, 15
        PRINT SPACE$(51)
        LOCATE 8, 15
        PRINT "    "; Versione$; " - Trasmissione tempi dei rally    "
        LOCATE 9, 15
        PRINT "        Questo programma  stato scritto da        "
        LOCATE 10, 15
        PRINT "                   IW1CNF & I1EPJ                  "
        LOCATE 11, 15
        PRINT " ed  distribuito nella speranza che sia utile ma  "
        LOCATE 12, 15
        PRINT " SENZA ALCUNA GARANZIA sotto la GNU Public License "
        LOCATE 13, 15
        PRINT "       Vedere il file COPYING per i dettagli       "
        LOCATE 14, 15
        PRINT SPACE$(51)
        LOCATE 15, 16
        COLOR Ombra, Sfondo
        PRINT STRING$(51, "");
        LOCATE 7, 66
        PRINT ""
        FOR I = 0 TO 6
                LOCATE 8 + I, 66
                PRINT ""
        NEXT
        EVENT ON
RETURN

' -----------------------------------------------------------------------
' Gestione CONTROL-C (ignorato e inviato al TNC).
' Per fermare il programma con le maniere forti usare CONTROL-BREAK
' -----------------------------------------------------------------------
CntrlC:
PRINT #1, CHR$(3);
RETURN

' ==========================< Subroutines >==============================

' -----------------------------------------------------------------------
' Apre la porta seriale
' -----------------------------------------------------------------------
ApriCom:
        OPEN COMPORT$ FOR RANDOM AS #1
        COM(COMNUM) ON
        ON COM(COMNUM) GOSUB ComHandler
RETURN

' -----------------------------------------------------------------------
' Salva il file di configurazione
' -----------------------------------------------------------------------
SalvaINI:
        n = 1
        nrec = 7
        OPEN "O", #4, "gpcmdat.ini"
        FOR ciclo = 1 TO nrec
                PRINT #4, I$(n)
                n = n + 1
        NEXT ciclo
        CLOSE #4
RETURN

' -----------------------------------------------------------------------
' Disegna la maschera
' -----------------------------------------------------------------------
DisegnaMaschera:
        VIEW PRINT 1 TO 24
        COLOR Titolo, Sfondo
        CLS
        PRINT CHR$(201);
        FOR I = 2 TO 79
                LOCATE 1, I: PRINT CHR$(205);
        NEXT
        PRINT CHR$(187);
        FOR I = 2 TO 80
                LOCATE 3, I: PRINT CHR$(205);
        NEXT
        LOCATE 3, 80: PRINT CHR$(188);

        FOR I = 1 TO 80
                LOCATE 18, I: PRINT CHR$(205);
        NEXT
        FOR I = 1 TO 80
                LOCATE 24, I: PRINT CHR$(205);
        NEXT
        LOCATE 18, 32: PRINT CHR$(185); " Mini-Terminale "; CHR$(204)
        LOCATE 2, 1: PRINT CHR$(186);
        LOCATE 1, 12: PRINT CHR$(203);
        LOCATE 2, 12: PRINT CHR$(186);
        LOCATE 3, 12: PRINT CHR$(202);
        LOCATE 1, 71: PRINT CHR$(203);
        LOCATE 2, 71: PRINT CHR$(186);
        LOCATE 3, 71: PRINT CHR$(202);
        LOCATE 2, 80: PRINT CHR$(186);
        LOCATE 3, 1: PRINT CHR$(200);

RETURN
' -----------------------------------------------------------------------
' Visualizza il foglio
' -----------------------------------------------------------------------
VisualFoglio:
        EVENT OFF
        FOR I = 1 TO 12
                COLOR Sfondo, Sfondo
                LOCATE 3 + I, 23
                PRINT SPACE$(40)
                Stampa$(I) = ""
        NEXT
        COLOR FileTit, SfondoTit
        LOCATE 4, 23
        OPEN "I", #4, Fogli$(start + filep - 1)
        IF Editing = 1 THEN
                L$ = "File: " + LEFT$(Fogli$(start + filep - 1) + SPACE$(40), 12) + " Riga:    Car:    Ins"
        ELSE
                L$ = "  Contenuto di '" + Fogli$(start + filep - 1) + "' (" + LTRIM$(STR$(LOF(4))) + " bytes)"
        END IF
        PRINT LEFT$(L$ + SPACE$(40), 40);
        COLOR Testo, SfondoTesto
        R = 1
        WHILE NOT EOF(4)
                LINE INPUT #4, Stampa$(R)
                R = R + 1
        WEND
        CLOSE #4
        nrec = R
        IF Editing = 1 THEN last = 12 ELSE last = nrec - 1
        FOR n = 1 TO last
                LOCATE 4 + n, 23
                PRINT LEFT$(Stampa$(n) + SPACE$(40), 40);
        NEXT
        EVENT ON
RETURN
' -----------------------------------------------------------------------
' Edita il foglio
' -----------------------------------------------------------------------
Edit:
        Row = 5
        Col = 23
        Ins = 1
        ON ERROR GOTO 0
        DO
                EVENT OFF
                VIEW PRINT 4 TO 17
                LOCATE 4, 47
                COLOR FileTit, SfondoTit
                PRINT USING "##"; Row - 4
                LOCATE 4, 55
                PRINT USING "##"; Col - 22
                LOCATE 4, 59
                IF Ins = 0 THEN
                        PRINT "Ovr"
                ELSE
                        PRINT "Ins"
                END IF
                VIEW PRINT 5 TO 17
                li$ = LEFT$(Stampa$(Row - 4) + SPACE$(40), 40)
                COLOR Testo, SfondoTesto
                LOCATE Row, 23
                PRINT li$;
                LOCATE Row, Col
                ch = SCREEN(Row, Col)
                COLOR SfondoTesto, Testo
                PRINT CHR$(ch);
                LOCATE Row, Col
                EVENT ON
                DO
                        C$ = INKEY$
                LOOP UNTIL C$ <> ""
                EVENT OFF
                COLOR Testo, SfondoTesto
                LOCATE Row, Col
                PRINT CHR$(ch);
                LOCATE Row, Col
                IF LEN(C$) = 2 THEN
                        IF LEFT$(C$, 1) = CHR$(0) THEN
                                SELECT CASE RIGHT$(C$, 1)
                                        CASE CHR$(72) 'UP
                                                IF Row > 5 THEN Row = Row - 1
                                        CASE CHR$(75) 'LEFT
                                                IF Col > 23 THEN Col = Col - 1
                                        CASE CHR$(77) 'RIGHT
                                                IF Col < 62 THEN Col = Col + 1
                                        CASE CHR$(80) 'DOWN
                                                IF Row < 16 THEN Row = Row + 1
                                        CASE CHR$(82) 'INS
                                                IF Ins = 0 THEN Ins = 1 ELSE Ins = 0
                                        CASE CHR$(83) 'DEL
                                                IF LEN(RTRIM$(li$)) = 0 THEN
                                                        FOR n = Row - 4 TO 11
                                                                Stampa$(n) = Stampa$(n + 1)
                                                                LOCATE 4 + n, 23
                                                                PRINT LEFT$(Stampa$(n) + SPACE$(40), 40);
                                                        NEXT
                                                ELSE
                                                        li$ = LEFT$(li$, Col - 23) + MID$(li$, Col - 21)
                                                        Stampa$(Row - 4) = RTRIM$(li$)
                                                END IF
                                END SELECT
                        END IF
                ELSEIF C$ = CHR$(13) THEN
                        IF (Ins = 1) AND (Row < 16) THEN
                                IF (Col > 23) THEN Row = Row + 1
                                FOR n = 11 TO Row - 4 STEP -1
                                        Stampa$(n + 1) = Stampa$(n)
                                NEXT
                                Stampa$(Row - 4) = ""
                                FOR n = 1 TO 12
                                        LOCATE 4 + n, 23
                                        PRINT LEFT$(Stampa$(n) + SPACE$(40), 40);
                                NEXT
                        END IF
                        IF (Col = 23) AND (Row < 16) THEN Row = Row + 1
                        Col = 23
                ELSEIF C$ <> CHR$(27) THEN
                        IF Col < 63 THEN
                                IF C$ = CHR$(9) THEN
                                        MID$(li$, Col - 22, 8) = SPACE$(8)
                                        Col = Col + 8
                                ELSEIF C$ = CHR$(8) THEN
                                        IF Col > 23 THEN
                                                li$ = LEFT$(li$, Col - 24) + MID$(li$, Col - 22)
                                                Col = Col - 1
                                        END IF
                                ELSE
                                        IF Ins = 1 THEN
                                                li$ = LEFT$(li$, Col - 23) + C$ + MID$(li$, Col - 22)
                                        ELSE
                                                MID$(li$, Col - 22, 1) = C$
                                        END IF
                                        Col = Col + 1
                                END IF
                                IF Col > 62 THEN Col = 62
                                Stampa$(Row - 4) = RTRIM$(li$)
                        ELSE
                                PLAY ("l30 N35")
                        END IF
                END IF
        LOOP UNTIL C$ = CHR$(27)
        C$ = ""
        nrec = 1
        VIEW PRINT 4 TO 17
        LOCATE 4, 23
        COLOR FileTit, SfondoTit
        LOCATE 4, 23
        PRINT LEFT$("Salvo il file '" + Fogli$(start + filep - 1) + "' (S/N)?" + SPACE$(40), 40);
        LOCATE 4, 57
        DO
                CALL StrLget(scelta$, "S", 1, 2, Dom, SfondoDom)
                scelta$ = UCASE$(scelta$)
        LOOP UNTIL scelta$ = "S" OR scelta$ = "N" OR scelta$ = ""
        IF scelta$ = "S" OR scelta$ = "" THEN
                OPEN "O", #4, Fogli$(start + filep - 1)
                FOR n = 1 TO 12
                        IF Stampa$(n) <> "" THEN
                                PRINT #4, Stampa$(n)
                        END IF
                NEXT
                CLOSE #4
        END IF
        FOR n = 1 TO 12
                IF Stampa$(n) <> "" THEN nrec = nrec + 1
        NEXT
        FOR n = 1 TO 13
                COLOR Sfondo, Sfondo
                LOCATE 3 + n, 23
                PRINT SPACE$(40)
        NEXT
RETURN

' -----------------------------------------------------------------------
' Visualizza gli switch accettati
' -----------------------------------------------------------------------
Istruzioni:
        '
        ' uso del programma
        '
        PRINT
        PRINT Versione$
        PRINT "(C) 1999-2008 IW1CNF & I1EPJ"
        PRINT "Uso: GPCMDat [/L] [/M] [/I] [/?]"
        PRINT "     /L  Disabilita il log di quanto ricevuto e trasmesso sul file GPCMDAT.LOG"
        PRINT "     /M  Modo monocromatico per display LCD (utilizza solo bianco e nero)"
        PRINT "     /I  Non inizializzare il TNC alla partenza (per TNC non TNC2-compatibili)"
        PRINT "     /?  Mostra questo testo di aiuto ed esce"
        PRINT
RETURN

' -----------------------------------------------------------------------
' Visualizza l'Aiuto
' -----------------------------------------------------------------------
StampaAiuto:
        VIEW PRINT 1 TO 3
        COLOR Titolo, Sfondo
        LOCATE 2, 13
        PRINT SPACE$(58)
        LOCATE 2, 22
        Titolo$ = Versione$ + " - Mini Terminale ed Aiuto     "
        PRINT Titolo$
        VIEW PRINT 4 TO 17
        COLOR Aiuto, Sfondo
        CLS (2)
        LOCATE 5, 33
        PRINT "Tasti funzione"
        LOCATE 6, 5
        PRINT STRING$(72, "")
        LOCATE 7, 18
        PRINT " F1  Configura i dati personali del programma"
        LOCATE 8, 9
        PRINT "Gestione  F2  Compila e trasmetti un nuovo foglio tempi"
        LOCATE 9, 9
        PRINT "   Fogli  F3  Carica, visualizza o edita un foglio gi compilato"
        LOCATE 10, 18
        PRINT " F4  Trasmetti l'ultimo foglio compilato o caricato"
        LOCATE 11, 18
        PRINT " F5  Seleziona la porta seriale da utilizzare"
        LOCATE 12, 9
        PRINT " Seriale  F6  Seleziona la velocit di comunicazione"
        LOCATE 13, 9
        PRINT "   e TNC  F7  Attiva/disattiva l'eco locale dei caratteri battuti"
        LOCATE 14, 18
        PRINT " F8  Inizializza il TNC coi parametri corretti (per TNC2!)"
        LOCATE 15, 9
        PRINT "   Aiuto  F9  Visualizza il testo che state leggendo"
        LOCATE 16, 9
        PRINT "  e fine  F10 Esci dal programma e torna al DOS"
RETURN

' -----------------------------------------------------------------------
' Ordina i nomi di file nell'array Fogli$
' -----------------------------------------------------------------------
SortFogli:
        scambiati = 1
        WHILE scambiati = 1
                scambiati = 0
                FOR I = 2 TO NumFile
                        IF VAL(MID$(Fogli$(I - 1), 4, 2)) > VAL(MID$(Fogli$(I), 4, 2)) THEN
                                T$ = Fogli$(I - 1)
                                Fogli$(I - 1) = Fogli$(I)
                                Fogli$(I) = T$
                                scambiati = 1
                        END IF
                NEXT
        WEND
RETURN
' -----------------------------------------------------------------------
' Disabilita i tasti funzione
' -----------------------------------------------------------------------
DisabilitaFKey:
        FOR nkey = 1 TO 10
                KEY(nkey) OFF
        NEXT
        KEY(31) OFF
RETURN

' -----------------------------------------------------------------------
' Abilita i tasti funzione
' -----------------------------------------------------------------------
AbilitaFKey:
        FOR nkey = 1 TO 10
                KEY(nkey) ON
        NEXT
        KEY(31) ON
RETURN

' =========================< Gestione eventi >===========================

' -----------------------------------------------------------------------
' Gestione evento ON COM
' -----------------------------------------------------------------------
ComHandler:
        EVENT OFF
        OldRow = CSRLIN
        OldCol = POS(0)
        VIEW PRINT 19 TO 23
        LOCATE TermRow, TermCol
        COLOR Cursore, Sfondo
        PRINT " ";
        LOCATE TermRow, TermCol
        COLOR Terminale, Sfondo
        WHILE NOT EOF(1)
                rx$ = INPUT$(1, #1)
                PRINT rx$;
                IF LOGGING THEN PRINT #5, rx$;
        WEND
        TermRow = CSRLIN
        TermCol = POS(0)
        LOCATE TermRow, TermCol
        COLOR Cursore, SfondoCursore
        PRINT " ";
        LOCATE TermRow, TermCol
        VIEW PRINT OldTop TO OldBottom
        IF OldRow < 19 THEN LOCATE OldRow, OldCol
        EVENT ON
RETURN

' -----------------------------------------------------------------------
' Gestione evento ON TIMER
' -----------------------------------------------------------------------
MostraOra:
        EVENT OFF
        OldRow = CSRLIN
        OldCol = POS(0)
        VIEW PRINT 1 TO 3
        COLOR ora, Sfondo
        LOCATE 2, 2
        PRINT MID$(DATE$, 4, 2) + "-" + LEFT$(DATE$, 2) + RIGHT$(DATE$, 5)
        LOCATE 2, 72
        PRINT TIME$
        VIEW PRINT OldTop TO OldBottom
        LOCATE OldRow, OldCol
        EVENT ON
RETURN

'========================< Gestione errori >=============================

' -----------------------------------------------------------------------
'Gestione errore mancanza gpcmdat.ini
' -----------------------------------------------------------------------
NoConfig:
        VIEW PRINT 4 TO 17
        CLS (1)
        COLOR Errore, SfondoErrore
        LOCATE 11, 21
        PRINT "    File GPCMDAT.INI non trovato.    "
        LOCATE 12, 21
        PRINT " Ne verr ora creato uno di default. "
        LOCATE 13, 21
        PRINT "   Premi un tasto per continuare.    "
        a$ = INPUT$(1)
        CLOSE 2
        GOSUB SalvaINI
        RESUME LeggiConfig

' -----------------------------------------------------------------------
' Gestione errore mancanza nufoglio.txt
' -----------------------------------------------------------------------
NoFoglio:
        VIEW PRINT 4 TO 17
        CLS (1)
        COLOR Errore, SfondoErrore
        LOCATE 10, 25
        PRINT SPACE$(33);
        LOCATE 11, 25
        PRINT SPACE$(33);
        LOCATE 12, 25
        PRINT SPACE$(33)
        DO
                LOCATE 11, 25
                PRINT " Numero del foglio iniziale: ";
                CALL StrLget(f$, "1", 4, 1, Errore, SfondoErrore)
        LOOP UNTIL (VAL(f$) > 0) OR f$ = ""
        IF f$ = "" THEN f$ = "1"
        OPEN "O", #3, "NuFoglio.txt"
        PRINT #3, f$
        CLOSE #3
        RESUME LeggiNumFoglio

' -----------------------------------------------------------------------
' Gestione errori generici
' -----------------------------------------------------------------------
GestioneErrori:
        EVENT OFF
        IF ERR = 57 THEN
                EVENT ON
                RESUME NEXT
        END IF
        OldRow = CSRLIN
        OldCol = POS(0)
        VIEW PRINT 4 TO 17
        CLS (2)
        COLOR Errore, SfondoErrore
        LOCATE 10, 20
        PRINT "Ahi!!! Si  verificato l'errore numero"; ERR
        LOCATE 12, 20
        COLOR PremiTasto, Sfondo
        PRINT "Premi un tasto qualsiasi per continuare";
        a$ = INPUT$(1)
        VIEW PRINT OldTop TO OldBottom
        LOCATE OldRow, OldCol
        EVENT ON
        RESUME NEXT
END

SUB StrLget (Riga$, Def$, MaxLun, AlNum, Fg, Bg)
        EVENT OFF
        R = CSRLIN
        C = POS(0)
        L = 0
        SELECT CASE AlNum
                CASE 0
                        ValCh$ = ""
                CASE 1
                        ValCh$ = "0123456789" + CHR$(13) + CHR$(8) + CHR$(27)
                CASE 2
                        ValCh$ = "SNsn" + CHR$(13) + CHR$(8) + CHR$(27)
                CASE 3
                        ValCh$ = "CDScds" + CHR$(13) + CHR$(8) + CHR$(27)
        END SELECT
        COLOR Fg, Bg
        PRINT SPACE$(MaxLun);
        LOCATE R, C
        IF Def$ <> "" THEN
                PRINT Def$;
                LOCATE R, C
        END IF
        Riga$ = Def$
        Ri = R
        Co = C
        cp = 1
        Ins = 0
        EVENT ON
        DO
                LOCATE Ri, Co
                Riga$ = LEFT$(Riga$, MaxLun)
                Lun = LEN(Riga$)
                IF cp <= MaxLun THEN
                        COLOR Cursore, SfondoCursore
                        PRINT CHR$(SCREEN(Ri, Co));
                END IF
                DO
                        a$ = INKEY$
                LOOP UNTIL ((a$ <> "") AND ((INSTR(ValCh$, a$) > 0) OR (ValCh$ = "")) OR (LEN(a$) = 2))
                EVENT OFF
                IF (a$ <> "") AND (a$ <> CHR$(13)) AND (a$ <> CHR$(8)) AND (LEFT$(a$, 1) <> CHR$(0)) AND (Def$ <> "") THEN
                        LOCATE R, C
                        COLOR Fg, Bg
                        PRINT SPACE$(MaxLun);
                        LOCATE R, C
                END IF
                IF Lun < MaxLun THEN
                        COLOR Fg, Bg
                        LOCATE Ri, Co
                        PRINT CHR$(SCREEN(Ri, Co));
                        LOCATE Ri, Co
                ELSE
                        LOCATE R, C
                        COLOR Fg, Bg
                        Riga$ = LEFT$(Riga$, MaxLun)
                        PRINT Riga$;
                        LOCATE R, C
                END IF
                IF LEN(a$) = 2 AND LEFT$(a$, 1) = CHR$(0) THEN
                        SELECT CASE RIGHT$(a$, 1)
                                CASE CHR$(75)
                                        IF cp > 1 THEN
                                                cp = cp - 1
                                                Co = Co - 1
                                        END IF
                                CASE CHR$(77)
                                        IF cp <= Lun THEN
                                                cp = cp + 1
                                                Co = Co + 1
                                        END IF
                                CASE CHR$(82)
                                        IF Ins = 0 THEN Ins = 1 ELSE Ins = 0
                                CASE CHR$(83)
                                        IF Lun > 0 THEN
                                                Riga$ = LEFT$(Riga$, cp - 1) + MID$(Riga$, cp + 1)
                                                LOCATE R, C
                                                COLOR Fg, Bg
                                                PRINT Riga$;
                                                IF Lun <= MaxLun THEN PRINT " ";
                                     END IF
                        END SELECT
                END IF
                IF (a$ = CHR$(8)) AND (cp > 1) THEN
                        Riga$ = LEFT$(Riga$, cp - 2) + MID$(Riga$, cp)
                        LOCATE R, C
                        COLOR Fg, Bg
                        PRINT Riga$; " ";
                        Co = Co - 1
                        cp = cp - 1
                END IF
                IF a$ = CHR$(27) THEN
                        Riga$ = CHR$(27)
                END IF
                IF (ASC(a$) > 31) AND (cp <= MaxLun) THEN
                        IF AlNum > 1 THEN a$ = UCASE$(a$)
                        IF Ins = 1 THEN
                                Riga$ = LEFT$(Riga$, cp - 1) + a$ + MID$(Riga$, cp)
                                Co = Co + 1
                                cp = cp + 1
                        ELSE
                                Riga$ = LEFT$(Riga$, cp - 1) + a$ + MID$(Riga$, cp + 1)
                                cp = cp + 1
                                Co = Co + 1
                        END IF
                        LOCATE R, C
                        COLOR Fg, Bg
                        PRINT Riga$;
                        LOCATE Ri, Co
                END IF
        LOOP UNTIL a$ = CHR$(13) OR a$ = CHR$(27)
END SUB

